# -*- coding: utf-8 -*-
"""
Spyder Editor

This is a temporary script file.
"""

from phase1 import Student
from phase1 import StudentsList
from phase1 import ManageNetworkList

import datetime
import random
from random import randint

def random_date(start=datetime.date(2010,1,1), end=datetime.date(2019,1,1)):
    """Generate a random datetime between `start` and `end`"""
    return start + datetime.timedelta(
        # Get a random amount of seconds between `start` and `end`
        seconds=random.randint(0, int((end - start).total_seconds())),
    )
    
    
#print(random_date())

emails=['isb@es.es','pmf@es.es','lmoreno@es.es','brz@es.es','jmm@es.es','vsp@es.es','pr@es.es','jlc@es.es','abc@es.es','isa@es.es']
cities=['leganes','alcorcon','madrid','getafe','fuenlabrada','mostoles']
campuses=['leganes','toledo','colmenarejo','getafe']


def randomStudent():
    i=randint(0,len(emails)-1)
    email=emails[i]
    i=randint(0,len(cities)-1)
    city=cities[i]
    i=randint(0,len(campuses)-1)
    campus=campuses[i]
    
    student=Student(email,city,campus,random.randint(0,5),random_date())
    #student.show()
    return student


        
def testMerge(): 
    manage=ManageNetworkList()
    net1=StudentsList()
    for i in range(5):
        student=randomStudent()
        net1.addLast(student)
    print('social network 1')   
    print(str(net1)) 
    print()   
    
    net2=StudentsList()
    for i in range(3):
        student=randomStudent()
        net2.addLast(student)
    print('social network 2')   
    print(str(net2)) 
    
    network=manage.merge(net1,net2)
    print('social network merge')   
    
    print(str(network)) 

 
def testGetCampusCity():
    net=StudentsList()
    for i in range(10):
        student=randomStudent()
        net.addLast(student)
    print('social network 1')   
    print(str(net)) 
    print()   
    manage=ManageNetworkList()
    output1=manage.getCampusCity(net,1)
    print('social network opc=1')   
    print(str(output1)) 
    output2=manage.getCampusCity(net,2)
    print('social network opc=1')   
    print(str(output2)) 


def testLocateByCity():
    net=StudentsList()
    for i in range(20):
        student=randomStudent()
        net.addLast(student)
    print('social network 1')   
    print(str(net)) 
    print()   
    manage=ManageNetworkList()
    output1=manage.locateByCity(net,'madrid')
    print('social network opc=madrid')   
    print(str(output1)) 



def testGetStudentsByDateInterval():
    net=StudentsList()
    for i in range(20):
        student=randomStudent()
        net.addLast(student)
    print('social network 1')   
    print(str(net)) 
    print()   
    manage=ManageNetworkList()
    output1=manage.getStudentsByDateInterval(net,datetime.date(2015,1,1),datetime.date(2019,1,1))
    print('social network ', datetime.date(2015,1,1), datetime.date(2019,1,1))   
    print(str(output1)) 
 


def testorderBy():
    net=StudentsList()
    for i in range(20):
        student=randomStudent()
        net.addLast(student)
    print('social network 1')   
    print(str(net)) 
    print()   
    manage=ManageNetworkList()
    output1=manage.orderBy(net,1)
    print('ascending social network ')   
    print(str(output1)) 
    output1=manage.orderBy(net,2)
    print('descending social network ')   
    print(str(output1)) 

testMerge()
testGetCampusCity()
testLocateByCity()
testGetStudentsByDateInterval()
testorderBy()