# -*- coding: utf-8 -*-
"""
Spyder Editor

This is a temporary script file.
"""

from phase1 import Student
from phase1 import StudentsList
from phase2 import StudentsTree


import datetime
import random
from random import randint

def random_date(start=datetime.date(2010,1,1), end=datetime.date(2019,1,1)):
    """Generate a random datetime between `start` and `end`"""
    return start + datetime.timedelta(
        # Get a random amount of seconds between `start` and `end`
        seconds=random.randint(0, int((end - start).total_seconds())),
    )
    
    
#print(random_date())

emails=['isb@es.es','pmf@es.es','lmoreno@es.es','brz@es.es','jmm@es.es','vsp@es.es','pr@es.es','jlc@es.es','abc@es.es','isa@es.es']
cities=['leganes','alcorcon','madrid','getafe','fuenlabrada','mostoles']
campuses=['leganes','toledo','colmenarejo','getafe']


def randomStudent():
    i=randint(0,len(emails)-1)
    email=emails[i]
    i=randint(0,len(cities)-1)
    city=cities[i]
    i=randint(0,len(campuses)-1)
    campus=campuses[i]
    
    student=Student(email,city,campus,random.randint(0,5),random_date())
    #student.show()
    return student


        
def testTree(): 
    bst=StudentsTree()
    for i in range(10):
        student=randomStudent()
        bst.insert(student)
    bst.inorder()
    bst.preorder()
    bst.postorder()
    print(bst.search(Student('isb@isb.es','','',0,random_date())))
    bst.draw()
    student=Student('isa@es.es','','',0,random_date())
    bst.remove(student)
    bst.draw()

def test():
    net1=StudentsList()
    for i in range(20):
        student=randomStudent()
        net1.addLast(student)
    print('social network') 
    
    print(str(net1)) 
    bst=StudentsTree()
    print('TEST copySocialNetwork:\n:')
    
    bst.copySocialNetwork(net1)
    bst.draw()
    
    lst=bst.getOrderedList()
    print('TEST getOrderedList:\n:')
    print(str(lst)) 
    
    print('TEST deleteByNumberOfBlocks')

    bst.deleteByNumberOfBlocks(2)
    lst=bst.getOrderedList()
    print(str(lst)) 
    bst.draw()
    
    
    

testTree()
test()